# TODO:
# - mediaServer should have init-scripts, user, etc, etc...
# - package test apps (?)
#
# Conditional build:
%bcond_without	static_libs	# static libraries

Summary:	LIVE555 streaming media server
Summary(pl.UTF-8):	LIVE555 - serwer strumieni multimedialnych
Name:		live
Version:	2022.06.16
Release:	1
Epoch:		2
License:	LGPL v2.1+
Group:		Applications/Multimedia
Source0:	http://www.live555.com/liveMedia/public/%{name}.%{version}.tar.gz
# Source0-md5:	e9f877fa56ccc5f851dca461ae3bd4ab
Source1:	http://www.live555.com/liveMedia/public/changelog.txt
# Source1-md5:	38087728822d2ed08f60be3dd8dfc115
Patch0:		%{name}-link.patch
# from debian
Patch1:		%{name}-pkgconfig.patch
URL:		http://www.live555.com/liveMedia/
BuildRequires:	libstdc++-devel
BuildRequires:	openssl-devel
BuildRequires:	sed >= 4.0
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		specflags		-fno-strict-aliasing
# circular symbol dependencies with libBasicUsageEnvironment
%define		skip_post_check_so	.*%{_libdir}/libUsageEnvironment\.so.*

%description
LIVE555 streaming media server.

%description -l pl.UTF-8
LIVE555 - serwer strumieni multimedialnych.

%package libs
Summary:	Shared LIVE555 libraries for streaming media
Summary(pl.UTF-8):	Biblioteki współdzielone LIVE555 do strumieni multimedialnych
Group:		Libraries

%description libs
Shared LIVE555 libraries for streaming media.

%description libs -l pl.UTF-8
Biblioteki współdzielone LIVE555 do strumieni multimedialnych.

%package devel
Summary:	Header files for developing programs using LIVE555
Summary(pl.UTF-8):	Pliki nagłówkowe do biblioteki LIVE555
Group:		Development/Libraries
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
Requires:	libstdc++-devel
Obsoletes:	live < 2:2009.07.09-2.5

%description devel
Header files for developing programs using LIVE555.

%description devel -l pl.UTF-8
Pliki nagłówkowe do biblioteki LIVE555

%package static
Summary:	Static LIVE555 libraries for streaming media
Summary(pl.UTF-8):	Biblioteki statyczne LIVE555 do strumieni multimedialnych
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static LIVE555 libraries for streaming media.

%description static -l pl.UTF-8
Biblioteki statyczne LIVE555 do strumieni multimedialnych.

%prep
%setup -q -c
%patch0 -p1
%patch1 -p1

# disable building test programs
%{__sed} -i -e '/cd \$(TESTPROGS_DIR)/d' live/Makefile.tail

# out-of-source builds not supported, so clone sources for shared and static build
%if %{with static_libs}
cp -pPR live live-static
%endif
%{__mv} live live-shared

cp -af %{SOURCE1} ChangeLog.txt

%build
%if %{with static_libs}
cd live-static
./genMakefiles linux
%{__make} \
	C_COMPILER="%{__cc}" \
	CPLUSPLUS_COMPILER="%{__cxx}" \
	CPPFLAGS="%{rpmcppflags}" \
	CFLAGS="%{rpmcflags} -fPIC" \
	CXXFLAGS="%{rpmcxxflags} -fPIC"
cd ..
%endif

cd live-shared
./genMakefiles linux-with-shared-libraries
%{__make} \
	C_COMPILER="%{__cc}" \
	CPLUSPLUS_COMPILER="%{__cxx}" \
	CPPFLAGS="%{rpmcppflags}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	LIBRARY_LINK="%{__cxx} -o"

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
# static first so that binaries will be overwritten by shared version
%{__make} -C live-static install \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir} \
	DESTDIR=$RPM_BUILD_ROOT
%endif
	
%{__make} -C live-shared install \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir} \
	DESTDIR=$RPM_BUILD_ROOT
	
%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/live555HLSProxy
%attr(755,root,root) %{_bindir}/live555MediaServer
%attr(755,root,root) %{_bindir}/live555ProxyServer

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libBasicUsageEnvironment.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libBasicUsageEnvironment.so.1
%attr(755,root,root) %{_libdir}/libUsageEnvironment.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libUsageEnvironment.so.3
%attr(755,root,root) %{_libdir}/libgroupsock.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgroupsock.so.30
%attr(755,root,root) %{_libdir}/libliveMedia.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libliveMedia.so.107

%files devel
%defattr(644,root,root,755)
%doc ChangeLog.txt
%attr(755,root,root) %{_libdir}/libBasicUsageEnvironment.so
%attr(755,root,root) %{_libdir}/libUsageEnvironment.so
%attr(755,root,root) %{_libdir}/libgroupsock.so
%attr(755,root,root) %{_libdir}/libliveMedia.so
%{_includedir}/BasicUsageEnvironment
%{_includedir}/UsageEnvironment
%{_includedir}/groupsock
%{_includedir}/liveMedia
%{_pkgconfigdir}/live555.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libBasicUsageEnvironment.a
%{_libdir}/libUsageEnvironment.a
%{_libdir}/libgroupsock.a
%{_libdir}/libliveMedia.a
%endif
%changelog
* Sat Jul 09 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/live.git;a=log;h=master

* Sat Jul 09 2022 Jakub Bogusz <qboosh@pld-linux.org> ba18d9f
- updated to 2022.06.16 (new libliveMedia soname)

* Fri Apr 01 2022 Jakub Bogusz <qboosh@pld-linux.org> 22ca2a6
- updated to 2022.02.07 (new libliveMedia soname)

* Fri Sep 24 2021 Jan Rękorajski <baggins@pld-linux.org> 8be5d33
- rebuild with openssl 3.0.0

* Fri Apr 30 2021 Jakub Bogusz <qboosh@pld-linux.org> 4e0e02b
- rediffed patches

* Thu Apr 29 2021 Jakub Bogusz <qboosh@pld-linux.org> 51445b3
- updated to 2021.04.06 (new sonames)

* Sun Jan 17 2021 Jakub Bogusz <qboosh@pld-linux.org> a1791c8
- updated to 2021.01.16 (new libgroupsock and libliveMedia sonames)

* Fri Sep 25 2020 Jakub Bogusz <qboosh@pld-linux.org> c1d29b8
- updated to 2020.08.19 (new libliveMedia soname)

* Tue May 19 2020 Jakub Bogusz <qboosh@pld-linux.org> 9f53411
- updated to 2020.05.15 (new libliveMedia soname)
- updated link patch

* Wed Mar 18 2020 Jakub Bogusz <qboosh@pld-linux.org> fa75e60
- updated to 2020.03.06 (note: new libliveMedia soname; introduces HLSProxy and openssl support)
- updated link patch

* Tue Nov 05 2019 Jakub Bogusz <qboosh@pld-linux.org> 4849bb4
- updated to 2019.11.05 (note: new libliveMedia soname)

* Sun Aug 04 2019 Jakub Bogusz <qboosh@pld-linux.org> 7a509c3
- updated to 2019.07.27 (new libliveMedia soname)

* Mon Jul 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 9e35982
- updated to 2019.06.28 (new libliveMedia soname)

* Wed Mar 13 2019 Jan Rękorajski <baggins@pld-linux.org> a851aee
- release 2 (by relup.sh)

* Sun Feb 24 2019 Jakub Bogusz <qboosh@pld-linux.org> 1f863bb
- updated to 2019.02.03 (note: new libliveMedia soname)

* Mon Oct 22 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 7f5293a
- up to 2018.10.17; fixes CVE-2018-4013

* Sat Jul 29 2017 Jakub Bogusz <qboosh@pld-linux.org> 3c352f7
- updated to 2017.07.18

* Thu Jul 13 2017 Jakub Bogusz <qboosh@pld-linux.org> d91e053
- updated to 2017.06.04

* Tue May 16 2017 Jakub Bogusz <qboosh@pld-linux.org> 32fd552
- updated to 2017.04.26
- updated link patch
- dropped -shared.config, use upstream config for shared libraries build
- switched to upstream sonames (note: changed since previous PLD packaging) and includes layout

* Sun Feb 28 2016 Jakub Bogusz <qboosh@pld-linux.org> 83b7a79
- updated to 2016.02.22
- soname bumped due to ABI changes (use 7 to match gentoo)

* Thu Mar 19 2015 Adam Osuchowski <adwol@pld-linux.org> f9e099d
- up to 2015.03.16

